

/****** Object : Table [dbo].[ProcessTemp] Copyright TECK SYSTEM SOFT 2015 ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] SET [Customer] = '' WHERE [Customer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] SET [Site] = '' WHERE [Site] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] SET [Manager] = '' WHERE [Manager] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] SET [Severity] = '' WHERE [Severity] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] SET [Dashboard] = '' WHERE [Dashboard] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] SET [Domain] = '' WHERE [Domain] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] SET [Computer] = '' WHERE [Computer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] SET [Process] = '' WHERE [Process] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] SET [Status] = '' WHERE [Status] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] SET [Mode] = '' WHERE [Mode] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] SET [Alarm] = '' WHERE [Alarm] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] SET [Availability] = '' WHERE [Availability] IS NULL

 INSERT INTO [Monitorpack_GuardReportsMonitorpack].[dbo].[Process]
([Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Process]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
      ,[Availability]
)
SELECT  
GETDATE()
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain] 
      ,[Computer]
      ,[Process]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
	  ,CONVERT(nvarchar(10),[Availability]) 

FROM

(SELECT DISTINCT [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Process] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING
	   /*,[Insert_Date] Add for test purpose only */
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Process]
      ,[Status] 
      ,[Mode]
      ,[Alarm]
	  ,[Availability] 

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp]
WHERE [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Process] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  NOT IN 

(SELECT DISTINCT [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Process] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING
FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Process]) ) TBL 

/****** Object : UPDATE existing entries with the lastest values ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Process] 
SET  [Status] = REQUEST.[Status],
     [Alarm] = REQUEST.[Alarm],
     [Availability] = REQUEST.[Availability],
     [Insert_Date] = REQUEST.[Insert_Date] -- Last UPDATE time

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Process] PROCS,

/****** Object : Select values ******/

(SELECT TEMP_JOIN.[Process_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Process],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] TEMP
INNER JOIN  [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp] TEMP_JOIN 
ON TEMP_JOIN.[Mode] = TEMP.[Mode]

WHERE 
TEMP.[Customer] = TEMP_JOIN .[Customer] AND
TEMP.[Site] = TEMP_JOIN .[Site] AND
TEMP.[Domain] = TEMP_JOIN .[Domain] AND
TEMP.[Computer] = TEMP_JOIN .[Computer] AND
TEMP.[Process] =  TEMP_JOIN .[Process] AND
TEMP.[Mode] = TEMP_JOIN .[Mode] AND
TEMP.[Status] = TEMP_JOIN .[Status]AND
TEMP.[Alarm] = TEMP_JOIN .[Alarm] AND
TEMP.[Availability]=TEMP_JOIN.[Availability]

GROUP BY
TEMP_JOIN.[Process_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Process],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

HAVING max(TEMP.Process_ID) = TEMP_JOIN.[Process_ID]) AS REQUEST

WHERE
    PROCS.[Customer] = REQUEST.[Customer]
AND PROCS.[Site] = REQUEST.[Site]
AND PROCS.[Domain] = REQUEST.[Domain]
AND PROCS.[Computer] = REQUEST.[Computer]
AND PROCS.[Alarm] = REQUEST.[Alarm]
AND PROCS.[Availability] = REQUEST.[Availability]
AND PROCS.[Status] = REQUEST.[Status]

/****** Object : Clean Temporary SQL Table ******/

 /*TRUNCATE TABLE [Monitorpack_GuardReportsMonitorpack].[dbo].[ProcessTemp]*/
